(function(){
  var week = [ 'Sun',
                'Mon',
                'Tue',
                'Wed',
                'Thu',
                'Fri',
                'Sat'
              ],
      today = new Date().getDay(),
      hours = [];

  jQuery('#all-hours table:first tr, #all-hours ul:first li').each(function(){
    var match = jQuery(this).text().match(/(\w+)\s?-?–?\s?(\w+)?:?\s?(.+)/),
        daysHrs = match[3],
        i, days, l, day, range;
    //find days and time range
    //

    // extract start and end day
    days = match.splice(1,2);

    // convert day names to intergers
    for(i = 0, l = days.length; i<l; i++){
      day = days[i]?days[i].match(/\w{3}/)[0]:null;
      if(week.indexOf(day) < 0){
        days.splice(i,1);
      }else{
        days[i] = week.indexOf(day);
      }
    }

    // populate hours array
    if(days.length > 1){

      // if we have a range, loop through days between and populate
      range = days[1] - days[0];

      // if range is less than 0 then we started higher than we ended
      // jumping a weekend, so we get the last items and start from zero
      if(range < 0){
        for (i = days[0], l = 7-days[0]; i < 7; i++){
          hours[i] = daysHrs;
        }
        for (i = 0, l = days[1]; i <= l; i++){
          hours[i] = daysHrs;
        }
      // otherwise its a simple array population based on the range
      }else{
        for(i = days[0], l = days[0]+range; i <= l; i++){
          hours[i] = daysHrs;
        }
      }
    }else{
      // if just one day, add to hours array
      index = days[0];
      hours[index] = daysHrs;
    }

    var currentTime = new Date().getTime() / 1000;
    var holiday = false;

    // Show today's hours if current timestamp is bigger than holiday time.
    jQuery('table.holiday-hours tr').each(function(index) {
      var timestamp = jQuery(this).data('timestamp');
      if (currentTime >= timestamp) {
        holiday = jQuery(this).find('td:last').text();
      }
    });

    if (holiday) {
      hours[today] = holiday;
    }

  });
  jQuery('#todays-hours').html(hours[today]);

})();
